Attribute VB_Name = "modImportPhoenix"
Option Compare Database

Function fImportPhoenix() As String
On Error GoTo Err_fImportPhoenix

' ====== DECLARATIONS =========================================================== '
    
    '--General
    Dim i As Long
    Dim Msg As String
    Dim fld As Field
    Const xlCenter As Long = -4108
    Const xlBottom As Long = -4107
    
    '--Open Workbook
    Dim strDialogTitle As String
    Dim strPath As String
    
    '--Workbook Objects
    Dim ApXL As Object
    Dim xlWBk As Object
    Dim xlWSh As Object
    
    '--Worksheet Objects
    Dim xlWShExtract As Object
    Dim xlWShMarkers As Object
    Dim xlWShExRules As Object
    Dim Range As Object
    Dim CurrentRegion As Object
    Dim ActiveCell As Object
    Dim Columns As Object
    Dim Selection As Object
    
    '--Data Strings
    Dim strSample As String
    Dim strOrganism As String
    Dim strTestName As String
    Dim strRangeLeft
    Dim strRangeRight
    Dim strRange
            

' ====== OPEN WORKBOOK AND SHEET ================================================ '
' Notes: WORKING
        
    strDialogTitle = "Select a file for import"
    strPath = GetOpenFile_CLT(".\", strDialogTitle)
       
   'If no file was selected then the PathStrg variable will be empty.
   'If there was a file selected then.....
    
    If strPath <> "" Then
   
        Set ApXL = CreateObject("Excel.Application") 'invoke excel application
        Set xlWBk = ApXL.Workbooks.Open(strPath) 'open the selected file
        Set xlWSh = xlWBk.Worksheets("Sheet1")
        ApXL.Visible = True ' don't show the file to the user
        'ApXL.ScreenUpdating = False ' and don't show the processes
        'ApXL.ScreenUpdating = True ' but show the processes (to be placed at the end of the function when finished coding)
        
' ====== ADD NEW WORKSHEETS ===================================================== '
' Notes: DEVELOPING, but WORKING - unless otherwise stated
        
        ' check if additional worksheets exists, if not create them
        On Error Resume Next
            Set xlWShExtract = xlWBk.Sheets("Extract")
            Set xlWShMarkers = xlWBk.Sheets("Markers") ' this one yet to code
            Set xlWShExRules = xlWBk.Sheets("ExRules") ' this one yet to code
        On Error GoTo Err_fImportPhoenix
        
        ' ------ "EXTRACT" Results Extraction Worksheet ------------------------- '
        ' this worksheet will be used for importing into a temporary Access table
        
        If Not xlWShExtract Is Nothing Then
            'sheet has already been generated
            '(and thus imported, once i finish the code!, so exit for this file)
                'maybe check that the record exists...?
                'and/or ask if user wants to re-import? overwrite? etc...
            'End Function
        Else
            'does not exist, so add it
            ApXL.Worksheets.Add.Move After:=ApXL.Worksheets(ApXL.Worksheets.Count)
            ApXL.Sheets(ApXL.Worksheets.Count).Name = "Extract"
            
            Set xlWShExtract = xlWBk.Sheets("Extract")
            
            'copy over information from Sheet1.
            With xlWSh
                .Activate
                For i = 1 To .UsedRange.Rows.Count
                    If .Cells(i, 1) = "Isolate AST Results" Then
                        '.Cells(i + 2, 1).Activate '(don't actually need this)

                        'find the address of the appropriate range
                        strRangeLeft = ApXL.Cells(i + 2, 1).Address(0, 0)
                        strRangeRight = ApXL.Cells(i + 2, 9).Address(0, 0)
                        strRange = Chr$(34) & strRangeLeft & ":" & strRangeRight & Chr$(34)
                        'returns A1 range reference - e.g., "A24:I24"
                        'MsgBox strRange
                        
                        '' Error 91 - Object variable or With block variable not set
                        'ApXL.objRange = Chr$(34) & strRangeLeft & ":" & strRangeRight & Chr$(34)
                        
'' NUT OUT FROM HERE
'' -----------------
                        
                        ' Copies only either column A data, or first row of block data.
                        '.Range(ApXL.Cells(i + 2, 1), ApXL.Cells(i + 2, 9)).CurrentRegion.Copy Destination:=xlWShExtract.Range("A2")
                        '.Range("A24:I24").Copy Destination:=xlWShExtract.Range("A2")
                        
                        '' Error 1004 - Application-defined or object-defined error (does strRange need to be declared something different?
                        '.Range(strRange).Select
                        
                        '' Error 438 - Object does not support this property or method
                        '.Range(ApXL.strRange).Select
                        
                        '' Error 91 - object variable or with block variable not set
                        '.Range(Selection, Selection.End(xlDown)).Copy Destination:=xlWShExtract.Range("A2")
                        
                        '.Range(ApXL.objRange).CurrentRegion.Copy Destination:=xlWShExtract.Range("A2")
                        
                        ' Does not error, but also copies only column A
                        '.Range(ApXL.Cells(i + 2, 1), ApXL.Cells(i + 2, 9)).CurrentRegion.Copy Destination:=xlWShExtract.Range("A2")
                        
                        ' The following worked to copy correct data from Column A - it's a start!
                        '.Range(ApXL.Selection, ApXL.Selection).CurrentRegion.Copy Destination:=xlWShExtract.Range("A2")
                        
                        '' Error 1004 - Application-defined or object-defined error (does strRange need to be declared something different?
                        '.Range(ApXL.Selection, ApXL.Selection.End(xlDown)).Copy Destination:=xlWShExtract.Range("A2")
                        
                        '---- Recorded Excel Macro doing various interesting things ----
                        '' CopyDeleteMoveColumns Macro
                        '    Range("A24:I24").Select 'select the first antimicrobial and across to the Final SIR (9th col, 8 cols from A)
                        '    Range(Selection, Selection.End(xlDown)).Copy Destination:=xlWShExtract.Range("A2") 'copy/paste to Extract!A2
                        '---------------------------------------------------------------

                    End If
                Next
            End With
    
            MsgBox "Pause!"
'' -----------------
'' TO HERE
            
            With xlWShExtract
                .Activate
                
                ' -------- Move desired columns (don't need to delete empty cols, but does overwrite one)
                ApXL.Columns("C:C").Cut Destination:=ApXL.Columns("E:E")
                ApXL.Columns("I:I").Cut Destination:=ApXL.Columns("D:D")
                
                ' -------- add appropariate headers
                .Range("A1") = "Antimicrobial"
                .Range("B1") = "Qualifier"
                .Range("C1") = "Value"
                .Range("D1") = "SIR"
                .Range("E1") = "Reading"
                
                ' -------- formula for qualifier
                ' Must use RC[3] instead of "E2" for range source in formula  (relative reference)
                .Range("B2").FormulaR1C1 = "=IF(NOT(ISERROR(FIND(""="",RC[3]))),LEFT(RC[3],2),IF(OR(LEFT(RC[3],1)="">"",LEFT(RC[3],1)=""<""),LEFT(RC[3],1),""=""))"
                
                ' -------- formula for value
                ' chagned B2 to RC[-1] and E2 to RC[2] (relative reference)
                .Range("C2").FormulaR1C1 = "=IF(RC[-1]<>""="",RIGHT(RC[2],LEN(RC[2])-LEN(RC[-1])),RC[2])"

' NUT OUT FROM HERE ==============
                'now autofill down B2 and C2 the same number of rows as exists in column A
                 
                 ' Error 91 - Object variable or With block with variable not set
                 '.Range("B2:C2").AutoFill Destination:=Range("B2:C" & xlWShExtract.UsedRange.Rows.Count)
                 '.Range("B2:C2").AutoFill Destination:=Range("B2:C" & xlWShExtract.Rows.Count)
                 
                 ' Error 438 - Object does not support this property or method
                 '.Range("B2:C2").AutoFill Destination:=Range("B2:C" & .UsedRange.Rows.Count)
' TO HERE ==============
            
            End With
            
            'Pause
            MsgBox "I got to the clean up stage!"
        
            GoTo Clean_up
        
        End If
        
        ' ------ "MARKERS" Marker Rules Worksheet ------------------------------- '
        ' this worksheet will be used for importing into a temporary Access table
        
            ' First find where "Expert Triggered Rules" is located in Column A, and set this to lngLastFindRow
            ' Then, find where "Resistance Markers" is located in Column A, and for i=1 To lngLastFindRow, look for "Rule"&*
            ' For each "Rule"&* you find in that range, copy columns A,B and C to sheet xlWShMarkers
            ' OR - copy the whole range to xlWShMarkers and then somehow remove empty rows?
            ' LOL -> that would require knowing how to select a dynamic range! gaaaa!
        
        ' ------ "RULES" Expert Triggered Rules Worksheet ----------------------- '
        ' this worksheet will be used for importing into a temporary Access table
        
            ' copy and adpat from 'MARKERS' once it's working
        

' ====== FIND PRELIMINARY DATA ================================================== '
' Notes: WORKING
' Maybe make this into a separate function and pass just the search string?
        
        ' find the sample name and copy to string
        With xlWSh
            .Activate
            For i = 1 To lngRows
                If .Cells(i, 1) = "Accession #:" Then
                    .Cells(i, 2).Activate
                    strSample = .Cells(i, 2).Value
                End If
            Next
        End With
        
        ' find the organism name and copy to string
        With xlWSh
            For i = 1 To lngRows
                If .Cells(i, 1) = "Organism Name:" Then
                    .Cells(i, 2).Activate
                    strOrganism = .Cells(i, 2).Value
                End If
            Next
        End With
        
        ' find the test name and copy to string
        With xlWSh
            For i = 1 To lngRows
                If .Cells(i, 1) = "Test Name:" Then
                    .Cells(i, 2).Activate
                    strTestName = .Cells(i, 2).Value
                End If
            Next
        End With
        
        'copy all three strings to temporary table
        ' (yet to do) = INSERT statement?

' ====== CLEAN UP =============================================================== '
' Notes: WORKING

Clean_up:
        ' delete sheet while testing (code works!)
        ApXL.DisplayAlerts = False
        xlWShExtract.Delete
        'xlWBk.Sheets("Extract").Delete
        'xlWBk.Sheets("Markers").Delete
        'xlWBk.Sheets("ExRules").Delete
        ApXL.DisplayAlerts = True
    
        ' close instance of Excel
        xlWBk.Save
        xlWBk.Close
        ApXL.Quit
        Set xlWShExtract = Nothing
        Set xlWSh = Nothing
        Set xlWBk = Nothing
        Set ApXL = Nothing
        
        MsgBox "I've left everything neat and tidy for you"
        
   End If

Exit_fImportPhoenix:
    Exit Function

' ====== ERROR HANDLER ========================================================== '

Err_fImportPhoenix:
    
    ' delete sheet while testing (code works!)
    ApXL.DisplayAlerts = False
    xlWBk.Sheets("Extract").Delete
    'xlWBk.Sheets("Markers").Delete
    'xlWBk.Sheets("ExRules").Delete
    ApXL.DisplayAlerts = True
    
    ' close instance of Excel
    xlWBk.Save
    xlWBk.Close
    ApXL.Quit
    Set xlWShExtract = Nothing
    Set xlWSh = Nothing
    Set xlWBk = Nothing
    Set ApXL = Nothing

    ' "modFeatures" class module required for strings presented below
    Msg = "Error # " & Str(Err.Number) & Chr(13) & " (" & Err.Description & ")"
    Msg = Msg & Chr(13) & "in modImportPhoenix | fImportPhoenix"
    MsgBox Msg, vbOKOnly, fstrDBname & ": Error", Err.HelpFile, Err.HelpContext
    Resume Exit_fImportPhoenix

End Function
